/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.lib.basic.filters.AccumulateTimesteps;

/**
 *
 * @author Krzysztof S. Nowinski, University of Warsaw, ICM
 */
public class GUI extends javax.swing.JPanel
{

    private Params params = new Params();

    /**
     * Creates new form GUI
     */
    public GUI()
    {
        initComponents();
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents()
    {
        java.awt.GridBagConstraints gridBagConstraints;

        jPanel1 = new javax.swing.JPanel();
        resetButton = new javax.swing.JButton();
        accumulateToggle = new javax.swing.JToggleButton();
        coordsBox = new javax.swing.JCheckBox();
        dataBox = new javax.swing.JCheckBox();
        appendBox = new javax.swing.JCheckBox();
        maskBox = new javax.swing.JCheckBox();

        setLayout(new java.awt.GridBagLayout());
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 5;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        add(jPanel1, gridBagConstraints);

        resetButton.setText("reset");
        resetButton.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                resetButtonActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.insets = new java.awt.Insets(0, 0, 0, 15);
        add(resetButton, gridBagConstraints);

        accumulateToggle.setSelected(true);
        accumulateToggle.setText("accumulate");
        accumulateToggle.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                accumulateToggleActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        add(accumulateToggle, gridBagConstraints);

        coordsBox.setSelected(true);
        coordsBox.setText("merge coordinates");
        coordsBox.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                coordsBoxActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 2;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.LINE_START;
        add(coordsBox, gridBagConstraints);

        dataBox.setSelected(true);
        dataBox.setText("merge data");
        dataBox.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                dataBoxActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 3;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.LINE_START;
        add(dataBox, gridBagConstraints);

        appendBox.setSelected(true);
        appendBox.setText("auto-increment time");
        appendBox.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                appendBoxActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 4;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.ipadx = 1;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.LINE_START;
        add(appendBox, gridBagConstraints);

        maskBox.setSelected(true);
        maskBox.setText("merge masks");
        maskBox.addActionListener(new java.awt.event.ActionListener()
        {
            public void actionPerformed(java.awt.event.ActionEvent evt)
            {
                maskBoxActionPerformed(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 1;
        gridBagConstraints.gridwidth = 2;
        gridBagConstraints.fill = java.awt.GridBagConstraints.HORIZONTAL;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.LINE_START;
        add(maskBox, gridBagConstraints);
    }// </editor-fold>//GEN-END:initComponents

    private void resetButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_resetButtonActionPerformed
    {//GEN-HEADEREND:event_resetButtonActionPerformed
        if (params != null)
            params.setReset(true);
    }//GEN-LAST:event_resetButtonActionPerformed

    private void accumulateToggleActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_accumulateToggleActionPerformed
    {//GEN-HEADEREND:event_accumulateToggleActionPerformed
        if (params != null) {
            params.setappendTime(appendBox.isSelected());
            params.setMergeCoords(coordsBox.isSelected());
            params.setMergeData(dataBox.isSelected());
            params.setAccumulate(accumulateToggle.isSelected());
        }
    }//GEN-LAST:event_accumulateToggleActionPerformed

    private void coordsBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_coordsBoxActionPerformed
        if (params != null)
            params.setMergeCoords(coordsBox.isSelected());
    }//GEN-LAST:event_coordsBoxActionPerformed

    private void dataBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_dataBoxActionPerformed
        if (params != null)
            params.setMergeData(dataBox.isSelected());
    }//GEN-LAST:event_dataBoxActionPerformed

    private void appendBoxActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_appendBoxActionPerformed
        if (params != null)
            params.setappendTime(appendBox.isSelected());
    }//GEN-LAST:event_appendBoxActionPerformed

    private void maskBoxActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_maskBoxActionPerformed
    {//GEN-HEADEREND:event_maskBoxActionPerformed
        if (params != null)
            params.setMergeMasks(maskBox.isSelected());
    }//GEN-LAST:event_maskBoxActionPerformed

    public void setParams(Params params)
    {
        this.params = params;
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JToggleButton accumulateToggle;
    private javax.swing.JCheckBox appendBox;
    private javax.swing.JCheckBox coordsBox;
    private javax.swing.JCheckBox dataBox;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JCheckBox maskBox;
    private javax.swing.JButton resetButton;
    // End of variables declaration//GEN-END:variables

}
